package sequoia.path.alignment;

public class CellUnitInfo
{
    public double score;

    public Coord prevCell; // the previrous cell of the best local alignment that ends here

    public Coord startedAt;// the first cell of the best local alignment that ends here

    public int frameshiftCount = 0;

    public CellUnitInfo()
    {
        this(0);

    }

    public CellUnitInfo(double score)
    {
        this.score = score;
        prevCell = new Coord();
    }

    public CellUnitInfo(double score, int di, int dj, String k)
    {
        this.score = score;
        prevCell = new Coord(di, dj, k);
    }

    public CellUnitInfo(double score, int di, int dj, CellUnitKey k)
    {
        this.score = score;
        prevCell = new Coord(di, dj, k);
    }

    public void copyFrom(CellUnitInfo i)
    {
        score = i.score;
        prevCell.copyFrom(i.prevCell);
        // from.copyFrom(i.from);
    }

    @Override
    public String toString()
    {
        return "[" + score + ", " + prevCell.toString() + "]";
    }

    public int getFrameshiftCount()
    {
        return frameshiftCount;
    }

    public void setFrameshiftCount(int frameshiftCount)
    {
        this.frameshiftCount = frameshiftCount;
    }

    public Coord getPrevCell()
    {
        return prevCell;
    }

    public void setPrevCell(Coord prevCell)
    {
        this.prevCell = prevCell;
    }

    public double getScore()
    {
        return score;
    }

    public void setScore(double score)
    {
        this.score = score;
    }

    public Coord getMyStart()
    {
        if (this.startedAt == null) {
            return new Coord(0, 0, new CellUnitKey(null, null));
        }
        return startedAt;
    }

    public void setMyStart(Coord startsAt)
    {
        this.startedAt = startsAt;
    }
}
