package sequoia.path.alignment;

import sequoia.path.graph.Node;

public class Coord
{
    int Di = 0;

    int Dj = 0;

    CellUnitKey key;

    public Coord()
    {
        key = new CellUnitKey();
    }

    public Coord(int di, int dj, Node n1, Node n2)
    {
        Di = di;
        Dj = dj;
        setKey(n1, n2);
    }

    public Coord(int di, int dj, CellUnitKey k)
    {
        Di = di;
        Dj = dj;
        key = k;
    }

    public Coord(int di, int dj, String k)
    {
        Di = di;
        Dj = dj;
        key = new CellUnitKey(k);
    }

    public void copyFrom(Coord c)
    {
        Di = c.Di;
        Dj = c.Dj;
        key = c.key;
    }

    public CellUnitKey getFullKey()
    {
        return key;
    }

    public String getKey()
    {
        return key.key;
    }

    public int getDi()
    {
        return Di;
    }

    public int getDj()
    {
        return Dj;
    }

    public void setDi(int di)
    {
        Di = di;
    }

    public void setDj(int dj)
    {
        Dj = dj;
    }

    public Coord add(Coord c)
    {
        this.Di += c.Di;
        this.Dj += c.Dj;
        this.key = c.key;
        return this;
    }

    public void setKey(Node n1, Node n2)
    {
        key = new CellUnitKey(n1, n2);
    }
    
    

    @Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + Di;
		result = prime * result + Dj;
		result = prime * result + ((key == null) ? 0 : key.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Coord other = (Coord) obj;
		if (Di != other.Di)
			return false;
		if (Dj != other.Dj)
			return false;
		if (key == null) {
			if (other.key != null)
				return false;
		} else if (!key.equals(other.key))
			return false;
		return true;
	}

	@Override
    public String toString()
    {
        return "(" + Di + ", " + Dj + ", " + key + ")";
    }

}
