package sequoia.path.alignment;

import sequoia.path.graph.Node;
import sequoia.path.graph.BackTranslationGraph;

public class GlobalDPAfGapAlignment extends GlobalDPAlignment
{
    // TODO the new changes on this class have not been tested in a loong time!

    // ************************************************************************
    // C O N S T R U C T O R S
    public GlobalDPAfGapAlignment(BackTranslationGraph A, BackTranslationGraph B)
    {
        super(A, B);
    }

    public GlobalDPAfGapAlignment(BackTranslationGraph A, BackTranslationGraph B, int d, int e, int m, int x)
    {
        super(A, B, d, e, m, x);
    }

    // ************************************************************************
    // C O M P U T E T H E S C O R E O F E A C H C E L L
    @Override
    protected void computeBestPartialScore(int i, int j, CellUnitKey k)
    {
        Node aNodes[] = A.getPrecNodes(i - 1, k.nA), bNodes[] = B.getPrecNodes(j - 1, k.nB);

        CellUnitInfo c = alignmentMatrix[i][j].get(k);
        c.score = Integer.MIN_VALUE;
        // c.setMyStart(new Coord(0, 0, new CellUnitKey(CellUnitKey.UNDEF_KEY))); This information is unnecessary in
        // global alignments; should be left null, to reduce space usage

        partialScoreOptionMatch(c, aNodes, bNodes, i, j, k);
        partialScoreOptionHGap(c, aNodes, i, j, k);
        partialScoreOptionVGap(c, bNodes, i, j, k);
    }
}
