package sequoia.path.alignment;

import sequoia.path.graph.Node;
import sequoia.path.graph.BackTranslationGraph;

public class OverlapDPAfGapAlignment extends OverlapDPAlignment
{
    // ************************************************************************
    // C O N S T R U C T O R S
    public OverlapDPAfGapAlignment(BackTranslationGraph A, BackTranslationGraph B)
    {
        super(A, B);
    }

    public OverlapDPAfGapAlignment(BackTranslationGraph A, BackTranslationGraph B, int d, int e, int m, int x)
    {
        super(A, B, d, e, m, x);
    }

    // ************************************************************************
    // C O M P U T E T H E S C O R E O F E A C H C E L L
    @Override
    protected void computeBestPartialScore(int i, int j, CellUnitKey k)
    {
        Node aNodes[] = A.getPrecNodes(i - 1, k.nA), bNodes[] = B.getPrecNodes(j - 1, k.nB);

        CellUnitInfo c = alignmentMatrix[i][j].get(k);
        c.score = Double.MIN_VALUE;

        partialScoreOptionMatch(c, aNodes, bNodes, i, j, k);
        partialScoreOptionHGap(c, aNodes, i, j, k);
        partialScoreOptionVGap(c, bNodes, i, j, k);
    }
}
