package sequoia.path.alignment.filter;

import sequoia.path.alignment.Alignment;

public class EValueAlignmentFilter extends AlignmentFilter
{
    public static final double DEFAULT_EVALUE_THRESHOLD = 1E-3;

    protected final double maxEValue;

    public EValueAlignmentFilter()
    {
        maxEValue = DEFAULT_EVALUE_THRESHOLD;
    }

    public EValueAlignmentFilter(double threshold)
    {
        maxEValue = threshold;
    }

    @Override
    public boolean accepts(Alignment a)
    {
        return a.getScoreSignificance() <= maxEValue;
    }

    @Override
    public String toString()
    {
        return "Accept if evalue <= " + maxEValue;
    }

}
