package sequoia.path.alignment.spaceecon;

import java.util.ArrayList;
import java.util.List;

import sequoia.path.alignment.CellUnitKey;
import sequoia.path.alignment.Coord;

public class AlignmentPoints
{
    ArrayList<AlignmentMatrixMilestone> points;

    double score = 0;

    AlignmentPoints(Coord from, Coord to, List<AlignmentMatrixMilestone> intermed, double Score)
    {
        score = Score;
        points = new ArrayList<AlignmentMatrixMilestone>(intermed != null ? intermed.size() : 0 + 2);
        if (from == null) {
            from = new Coord(-1, -1, new CellUnitKey(null, null));
        }
        points.add(new AlignmentMatrixMilestone(null, from));
        if (intermed != null) {
            points.addAll(intermed);
        }
        points.add(new AlignmentMatrixMilestone(to, null));
    }

    public int size()
    {
        return points.size();
    }

    public AlignmentMatrixMilestone get(int i)
    {
        return points.get(i);
    }
    
    public Coord getLeft(int i)
    {
        return points.get(i).getLeft();
    }
    
    public Coord getRight(int i)
    {
        return points.get(i).getRight();
    }

    public Coord getStart()
    {
        return get(0).getRight();
    }

    public Coord getEnd()
    {
        return get(points.size() - 1).getLeft();
    }

    @Override
    public String toString()
    {
        StringBuilder str = new StringBuilder();
        for (int i = 0; i < points.size(); ++i) {
            str.append(points.get(i));
            str.append(' ');
        }
        return str.toString();
    }

    public double getScore()
    {
        return score;
    }
}
