package sequoia.path.alignment.spaceecon;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import sequoia.path.alignment.CellUnitInfo;
import sequoia.path.alignment.CellUnitKey;
import sequoia.path.alignment.Coord;

public class ScanWindowCellUnitInfo extends CellUnitInfo
{
    ArrayList<AlignmentMatrixMilestone> milestones = new ArrayList<AlignmentMatrixMilestone>();

    ScanWindowCellUnitInfo()
    {
        super();
    }

    ScanWindowCellUnitInfo(double score)
    {
        super(score);
    }

    ScanWindowCellUnitInfo(double score, int di, int dj, String k)
    {
        super(score, di, dj, k);
    }

    ScanWindowCellUnitInfo(double score, Coord start)
    {
        this.score = score;
        this.startedAt = start;
    }

    public void update(double score, Coord start, Coord prev, int frameshifts)
    {
        this.score = score;
        this.startedAt = start;
        this.prevCell = prev;
        this.frameshiftCount = frameshifts;
    }

    public void update(double score, Coord prevCoord, ScanWindowCellUnitInfo prev)
    {
        this.score = score;
        this.startedAt = prev.startedAt;
        this.prevCell = prevCoord;
        this.frameshiftCount = prev.frameshiftCount;
    }

    public List<AlignmentMatrixMilestone> getMilestones()
    {
        return Collections.unmodifiableList(this.milestones);
    }

    public void addMilestone(AlignmentMatrixMilestone mi)
    {
        this.milestones.add(mi);
    }

    public void addMilestone(int col, int row, CellUnitKey k, Coord prev)
    {
    	 this.milestones.add(new AlignmentMatrixMilestone(col, row, k, prev));
    }

    public void setMilestones(ArrayList<AlignmentMatrixMilestone> m)
    {
        milestones = m; // TODO should i make an 'addAll' instead?
    }

    public void addMilestones(ArrayList<AlignmentMatrixMilestone> m)
    {
        milestones.addAll(m);
    }

    public String toString()
    {
        return score + "";
    }
}
