package sequoia.path.alignment.spaceecon;

import sequoia.path.alignment.Alignment;
import sequoia.path.alignment.CellUnitKey;
import sequoia.path.alignment.Coord;
import sequoia.path.alignment.LocalDPFSCGapAlignment;
import sequoia.path.graph.BackTranslationGraph;

public class SpaceEconomicLocalDPFSCAligner extends SpaceEconomicFSCAligner
{

    // Sequence A labels the columns (so it is horizontal); it is traversed by index i (or c...)
    // Sequence B labels the rows (so it is vertical ); it is traversed by index j
    // ************************************************************************
    // C O N S T R U C T O R S
    // public SpaceEconomicLocalDPFSCAligner(BackTranslationGraph a, BackTranslationGraph b, int scoreAtLeast) {
    // super(a, b, scoreAtLeast);
    // }

    public SpaceEconomicLocalDPFSCAligner(BackTranslationGraph A, BackTranslationGraph B, int d, int e, int m, int x,
        int codonSkip, int codonSkipExtend, int fsNo, double acceptedScore)
    {
        super(A, B, d, e, m, x, codonSkip, codonSkipExtend, fsNo, acceptedScore);
    }

    // ************************************************************************
    // I M P L E M E N T A T I O N S O F A B S T R A C T F U N C T I O N S
    @Override
    public double getCellUnitInitValue()
    {
        return 0;
    }

    @Override
    public double getBorderInitValue(int where)
    {
        return 0;
    }

    public void initCellUnitStartField(ScanWindowCellUnitInfo c, int i, int j, CellUnitKey k)
    {
        c.setMyStart(win.windowToMatrixCoord(new Coord(i, j, k)));
    }

    public void acknowledgeScore(int i, int j, CellUnitKey k)
    {
        this.list.update(i, j, k, this);
    }

    // ************************************************************************
    // SPECIFIC ALIGNERS FOR SUBMATRICES
    @Override
    public Alignment getFullmatrixAligner()
    {
        LocalDPFSCGapAlignment al =
            new LocalDPFSCGapAlignment(A, B, this.d, this.e, this.match, this.mismatch, this.codonSkip, this.codonSkipExtension,
                this.allowedFrameshifts);
        al.setScoreMatrix(this.getScoreMatrix());
        al.allowedFrameshifts = this.allowedFrameshifts;
        return al;
    }

	@Override
	public String traceBack(CellUnitKey k) {
		// TODO Auto-generated method stub
		return null;
	}
}
