package sequoia.path.alignment.spaceecon;

import sequoia.path.alignment.Alignment;
import sequoia.path.alignment.CellUnitKey;
import sequoia.path.alignment.Coord;
import sequoia.path.alignment.OverlapDPFSCGapAlignment;
import sequoia.path.graph.BackTranslationGraph;

public class SpaceEconomicOverlapDPFSCAligner extends SpaceEconomicFSCAligner
{
    // Seqence A labels the columns (so it is horizontal); it is traversed by index i (or c...)
    // Seqence B labels the rowq (so it is vertical ); it is traversed by index j
    // ************************************************************************
    // C O N S T R U C T O R S

    public SpaceEconomicOverlapDPFSCAligner(BackTranslationGraph A, BackTranslationGraph B, int d, int e, int m, int x,
        int codonSkip, int codonSkipExtension, int fsNo, double acceptedScore)
    {
        super(A, B, d, e, m, x, codonSkip, codonSkipExtension, fsNo, acceptedScore);
    }

    // ************************************************************************
    // I N I T I A L I Z A T I O N
    @Override
    public void init(BackTranslationGraph a, BackTranslationGraph b)
    {
        super.init(a, b);
    }

    // ************************************************************************
    // I M P L E M E N T A T I O N S O F A B S T R A C T F U N C T I O N S
    @Override
    public double getCellUnitInitValue()
    {
        return Double.MIN_VALUE;
    }

    @Override
    public double getBorderInitValue(int where)
    {
        return 0;
    }

    @Override
    public void initCellUnitStartField(ScanWindowCellUnitInfo c, int i, int j, CellUnitKey k)
    {
        // FIXME This is wrong
        c.setMyStart(win.windowToMatrixCoord(new Coord(i, j, k)));
    }

    @Override
    public void acknowledgeScore(int i, int j, CellUnitKey k)
    {
        if (win.windowToMatrixIdx(i) == A.size() || j == B.size()) {
            this.list.update(i, j, k, this);
        }
    }

    // ************************************************************************
    // SPECIFIC ALIGNERS FOR SUBMATRICES
    @Override
    public Alignment getFullmatrixAligner()
    {
        OverlapDPFSCGapAlignment al =
            new OverlapDPFSCGapAlignment(A, B, this.d, this.e, this.match, this.mismatch, this.codonSkip, this.codonSkipExtension,
                this.allowedFrameshifts);
        al.setScoreMatrix(this.getScoreMatrix());
        al.allowedFrameshifts = this.allowedFrameshifts;
        return al;
    }

}
