package sequoia.path.data;

import sequoia.path.params.Parameters;
import sequoia.path.util.DBSequence;

public class DoubleDBData extends Data
{
    int bound;

    @Override
    public void setStartIdx(int val)
    {
        setStartIdx(val, firstJFor(val));
    }

    @Override
    void setStartIdx(int valI, int valJ)
    {
        startI = valI;
        startJ = valJ;
        reset();
    }

    @Override
    void reset()
    {
        grI = startI;
        grJ = startJ;
    }

    @Override
    protected int firstJFor(int i)
    {
        return bound;
    }

    public void setBound(int b)
    {
        bound = b;
    }

    @Override
    public void setEndIdx(int val)
    {
        endI = val;
        endJ = -1;
    }

    @Override
    void setEndIdx(int valI, int valJ)
    {
        endI = valI;
        endJ = valJ;
    }

    @Override
    public void doneLoading()
    {
        if (endI == -1 || endI > bound - 1) {
            endI = bound - 1;
        }
        if (endJ == -1 || endJ > getGraphs().size() - 1) {
            endJ = seqs.size() - 1;
        }

        startJ = bound;
        reset();
        if (! params.isQuiet()) {
          System.out.println("Loaded " + seqs.size() + " sequences.");
        }
    }

    public DoubleDBData(Parameters p)
    {
        super(p);
    }

    DBSequence getSeq(int i, boolean secondDB)
    {
        return seqs.get(i + bound);
    }

    @Override
    public boolean hasMoreAlignments()
    {
        return grI <= endI && grJ <= endJ;
    }
    
    public int alignmentsCount() {
    	return ((endI>0?endI:bound)-startI) * ((endJ>0?endJ:(seqs.size()-bound)) - startJ) * (r?2:1);
    }
}
