package sequoia.path.graph;

import sequoia.path.util.GenomicSequenceUtils;

public class NodeWeightEncDec
{

    private static int DEFAULT_SHIFT = 7;

    private static double trim(double val)
    {
        // we only work with values in [0, 1];
        // a precision of about DEFAULT_SHIFT decimals is sufficient
        return ((int) (val * Math.pow(10, DEFAULT_SHIFT))) / Math.pow(10, DEFAULT_SHIFT);
    }

    private static int getShift(char symbol)
    {
        return GenomicSequenceUtils.getCode(symbol) * DEFAULT_SHIFT;
    }

    public static double putSymbolWeight(double prevVal, double toInclude, char symb)
    {
        return prevVal + trim(toInclude) * Math.pow(10, getShift(symb));
    }

    public static double getSymbolWeight(double val, char symb)
    {
    	double rval = trim(val / Math.pow(10, getShift(symb)));
        return rval - Math.floor(rval);
    }
}
