package sequoia.path.scorematrixbuilder.mutation;

import sequoia.path.scorematrixbuilder.matrix.SquareMatrix;
import sequoia.path.util.Codon;

public class Mutate
{

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        String sequence = "";
        double evolutionaryDistance = 0;
        int readingFrame = 0;
        for (String arg : args) {
            if (arg.startsWith("-f")) {
                try {
                    readingFrame = Integer.parseInt(arg.substring(2));
                    if (readingFrame >= Codon.CODON_LEN) {
                        readingFrame %= Codon.CODON_LEN;
                    }
                } catch (Exception ex) {
                }
            } else if (arg.startsWith("-e")) {
                try {
                    evolutionaryDistance = Double.parseDouble(arg.substring(2));
                } catch (Exception ex) {
                }
            } else {
                sequence = arg;
            }
        }

        CodonMutator m =
            new CodonMutator(SquareMatrix.loadFromSimpleFile(ClassLoader.getSystemResourceAsStream(String.format(
                "cmpm%05.2f.mat", evolutionaryDistance))));

        System.out.println(mutate(sequence, m, readingFrame));

    }

    static String mutate(String seq, CodonMutator m, int readingFrame)
    {
        StringBuilder result = new StringBuilder(seq.length());
        result.append(seq.substring(0, readingFrame));
        int i = 0;
        for (i = readingFrame; i <= seq.length() - Codon.CODON_LEN; i += Codon.CODON_LEN) {
            result.append(m.codons[m.randomCodonMutation(new Codon(seq.substring(i, i + Codon.CODON_LEN), 1, 'X')
                .getID())].getSeq());
        }
        result.append(seq.substring(i));
        return result.toString();
    }
}
