package sequoia.path.scores;

import java.util.Set;

public interface ScoreMatrix
{
	public Object get(SymbolPairAlignmentData spd);

    public Object get(SymbolData s1, SymbolData s2);

    public Object get(char n1, char aa1, int p1, boolean rc1, char n2, char aa2, int p2, boolean rc2);

    public double getScore(SymbolPairAlignmentData spd);

    public double getScore(SymbolData s1, SymbolData s2);

    public double getScore(char n1, char aa1, int p1, boolean rc1, char n2, char aa2, int p2, boolean rc2);

    public String getNPair(SymbolPairAlignmentData spd);

    public String getNPair(SymbolData s1, SymbolData s2);

    public String getNPair(char n1, char aa1, int p1, boolean rc1, char n2, char aa2, int p2, boolean rc2);

    public Set<SymbolPairAlignmentData> getAllSymbolPairs();
    
    public void set(SymbolPairAlignmentData spd, double score);
    
    public Object clone();
    
    public void clear();
    
}
