package sequoia.path.util;

public class DBSequence
{
    static private int seqNo = 1;

    private final String seq;

    private final String id;

    public DBSequence(String s, String i)
    {
        seq = ProteinSeqUtils.cleanSequence(s);
        id = i;
    }

    public DBSequence(String s)
    {
        seq = ProteinSeqUtils.cleanSequence(s);
        id = "SEQ" + String.format("%4d", seqNo);
        ++seqNo;
    }

    public String getId()
    {
        return id;
    }

    public String getSeq()
    {
        return seq;
    }

    @Override
    public String toString()
    {
        return id + "\t" + seq;
    }
    
    public String toFasta()
    {
    	int charsPerRow = 60;
    	StringBuilder str = new StringBuilder();
    	if (!id.startsWith(">")) {
    		str.append(">");
    	}
    	str.append(id);
    	str.append("\n");
    	for (int i = 0; i < this.seq.length(); i += charsPerRow) {
            str.append(this.seq.substring(i, Math.min(i + charsPerRow, this.seq.length())));
            str.append('\n');
        }
        return str.toString();
    }
}
