package sequoia.path.util;

public class ProteinSeqUtils extends BaseSequenceUtils
{
    protected static final String AAs = "ARNDCQEGHILKMFPSTWYVU";

    protected static final String AAGroups = "ZBJX";

    public static final char ANY_AA = 'X';
    public static final char STOP = '*';

    protected static final String FORBIDDEN_SYMBOLS = "O";

    static {
        validSymbols = AAs + AAGroups;
    }

    public static boolean isRC(char aa)
    {
        return isValidSymbol(Character.toUpperCase(aa)) && Character.isLowerCase(aa);
    }

    public static char toRC(char aa)
    {
        return Character.isUpperCase(aa) ? Character.toLowerCase(aa) : Character.toUpperCase(aa);
    }
    
    public static char toStd(char aa)
    {
        return Character.toUpperCase(aa);
    }
    
    protected static String cleanSequence(String seq) {
    	return seq.toUpperCase().replaceAll("[^A-Z\\" + STOP + "]", "").replaceAll("[^" + AAs + "]", ANY_AA + "");
    }
}
